<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_result_provider".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanResultProvider".
 *
 * Columns in table "scan_result_provider" available as properties of the model,
 * followed by relations of table "scan_result_provider" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_request_provider_id
 * @property integer $listing_type_id
 * @property integer $is_featured
 * @property integer $review_number
 * @property string $review_average
 * @property integer $match_name
 * @property integer $match_phone
 * @property integer $match_address
 * @property integer $match_zipcode
 * @property integer $match_city
 * @property double $distance
 * @property integer $match_near_location
 * @property integer $match_state
 * @property string $match_specialty
 * @property string $url
 * @property string $scraped_name
 * @property string $scraped_phone
 * @property string $scraped_address
 * @property string $scraped_zipcode
 * @property string $scraped_city
 * @property string $scraped_state
 * @property string $scraped_state_abbreviation
 * @property double $scraped_latitude
 * @property double $scraped_longitude
 * @property string $scraped_specialty
 * @property integer $scraped_featured
 * @property double $specialty_similarity
 * @property string $specialty_similarity_match
 * @property integer $has_appointments
 * @property integer $ddc_appointments
 * @property string $appointments_url
 * @property string $photo
 * @property integer $default_photo
 *
 * @property ScanError[] $scanErrors
 * @property ScanRequestProvider $scanRequestProvider
 * @property ScanSourceProvider[] $scanSourceProviders
 */
abstract class BaseScanResultProvider extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_result_provider';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanResultProvider|ScanResultProviders', $n);
    }

    public static function representingColumn()
    {
        return 'review_average';
    }

    public function rules()
    {
        return array(
            array('scan_request_provider_id', 'required'),
            array('scan_request_provider_id, listing_type_id, is_featured, review_number, match_name, match_phone, match_address, match_zipcode, match_city, match_near_location, match_state, scraped_featured, has_appointments, ddc_appointments, default_photo', 'numerical', 'integerOnly'=>true),
            array('distance, scraped_latitude, scraped_longitude, specialty_similarity', 'numerical'),
            array('review_average', 'length', 'max'=>3),
            array('match_specialty', 'length', 'max'=>45),
            array('url, scraped_name, scraped_phone, scraped_address, scraped_specialty', 'length', 'max'=>255),
            array('scraped_zipcode', 'length', 'max'=>10),
            array('scraped_city, scraped_state, scraped_state_abbreviation', 'length', 'max'=>50),
            array('specialty_similarity_match', 'length', 'max'=>100),
            array('appointments_url, photo', 'safe'),
            array('listing_type_id, is_featured, review_number, review_average, match_name, match_phone, match_address, match_zipcode, match_city, distance, match_near_location, match_state, match_specialty, url, scraped_name, scraped_phone, scraped_address, scraped_zipcode, scraped_city, scraped_state, scraped_state_abbreviation, scraped_latitude, scraped_longitude, scraped_specialty, scraped_featured, specialty_similarity, specialty_similarity_match, has_appointments, ddc_appointments, appointments_url, photo, default_photo', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, scan_request_provider_id, listing_type_id, is_featured, review_number, review_average, match_name, match_phone, match_address, match_zipcode, match_city, distance, match_near_location, match_state, match_specialty, url, scraped_name, scraped_phone, scraped_address, scraped_zipcode, scraped_city, scraped_state, scraped_state_abbreviation, scraped_latitude, scraped_longitude, scraped_specialty, scraped_featured, specialty_similarity, specialty_similarity_match, has_appointments, ddc_appointments, appointments_url, photo, default_photo', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanErrors' => array(self::HAS_MANY, 'ScanError', 'scan_result_provider_id'),
            'scanRequestProvider' => array(self::BELONGS_TO, 'ScanRequestProvider', 'scan_request_provider_id'),
            'scanSourceProviders' => array(self::HAS_MANY, 'ScanSourceProvider', 'scan_result_provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_request_provider_id' => null,
            'listing_type_id' => Yii::t('app', 'Listing Type'),
            'is_featured' => Yii::t('app', 'Is Featured'),
            'review_number' => Yii::t('app', 'Review Number'),
            'review_average' => Yii::t('app', 'Review Average'),
            'match_name' => Yii::t('app', 'Match Name'),
            'match_phone' => Yii::t('app', 'Match Phone'),
            'match_address' => Yii::t('app', 'Match Address'),
            'match_zipcode' => Yii::t('app', 'Match Zipcode'),
            'match_city' => Yii::t('app', 'Match City'),
            'distance' => Yii::t('app', 'Distance'),
            'match_near_location' => Yii::t('app', 'Match Near Location'),
            'match_state' => Yii::t('app', 'Match State'),
            'match_specialty' => Yii::t('app', 'Match Specialty'),
            'url' => Yii::t('app', 'Url'),
            'scraped_name' => Yii::t('app', 'Scraped Name'),
            'scraped_phone' => Yii::t('app', 'Scraped Phone'),
            'scraped_address' => Yii::t('app', 'Scraped Address'),
            'scraped_zipcode' => Yii::t('app', 'Scraped Zipcode'),
            'scraped_city' => Yii::t('app', 'Scraped City'),
            'scraped_state' => Yii::t('app', 'Scraped State'),
            'scraped_state_abbreviation' => Yii::t('app', 'Scraped State Abbreviation'),
            'scraped_latitude' => Yii::t('app', 'Scraped Latitude'),
            'scraped_longitude' => Yii::t('app', 'Scraped Longitude'),
            'scraped_specialty' => Yii::t('app', 'Scraped Specialty'),
            'scraped_featured' => Yii::t('app', 'Scraped Featured'),
            'specialty_similarity' => Yii::t('app', 'Specialty Similarity'),
            'specialty_similarity_match' => Yii::t('app', 'Specialty Similarity Match'),
            'has_appointments' => Yii::t('app', 'Has Appointments'),
            'ddc_appointments' => Yii::t('app', 'Ddc Appointments'),
            'appointments_url' => Yii::t('app', 'Appointments Url'),
            'photo' => Yii::t('app', 'Photo'),
            'default_photo' => Yii::t('app', 'Default Photo'),
            'scanErrors' => null,
            'scanRequestProvider' => null,
            'scanSourceProviders' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_request_provider_id', $this->scan_request_provider_id);
        $criteria->compare('listing_type_id', $this->listing_type_id);
        $criteria->compare('is_featured', $this->is_featured);
        $criteria->compare('review_number', $this->review_number);
        $criteria->compare('review_average', $this->review_average, true);
        $criteria->compare('match_name', $this->match_name);
        $criteria->compare('match_phone', $this->match_phone);
        $criteria->compare('match_address', $this->match_address);
        $criteria->compare('match_zipcode', $this->match_zipcode);
        $criteria->compare('match_city', $this->match_city);
        $criteria->compare('distance', $this->distance);
        $criteria->compare('match_near_location', $this->match_near_location);
        $criteria->compare('match_state', $this->match_state);
        $criteria->compare('match_specialty', $this->match_specialty, true);
        $criteria->compare('url', $this->url, true);
        $criteria->compare('scraped_name', $this->scraped_name, true);
        $criteria->compare('scraped_phone', $this->scraped_phone, true);
        $criteria->compare('scraped_address', $this->scraped_address, true);
        $criteria->compare('scraped_zipcode', $this->scraped_zipcode, true);
        $criteria->compare('scraped_city', $this->scraped_city, true);
        $criteria->compare('scraped_state', $this->scraped_state, true);
        $criteria->compare('scraped_state_abbreviation', $this->scraped_state_abbreviation, true);
        $criteria->compare('scraped_latitude', $this->scraped_latitude);
        $criteria->compare('scraped_longitude', $this->scraped_longitude);
        $criteria->compare('scraped_specialty', $this->scraped_specialty, true);
        $criteria->compare('scraped_featured', $this->scraped_featured);
        $criteria->compare('specialty_similarity', $this->specialty_similarity);
        $criteria->compare('specialty_similarity_match', $this->specialty_similarity_match, true);
        $criteria->compare('has_appointments', $this->has_appointments);
        $criteria->compare('ddc_appointments', $this->ddc_appointments);
        $criteria->compare('appointments_url', $this->appointments_url, true);
        $criteria->compare('photo', $this->photo, true);
        $criteria->compare('default_photo', $this->default_photo);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
